program Project1;

uses
  windows, messages, DirectDraw, ddutil;

{$R *.RES}

var
 Instance: HWnd;
 WindowClass: TWndClass;
 Handle: HWnd;
 msg: TMsg;
 FDirectDraw : IDirectDraw7;
 FPrimarySurface : IDirectDrawSurface7;// 
 FBackgroundSurface : IDirectDrawSurface7;// 
 FTransImageSurface : IDirectDrawSurface7;//  
 FImageSurface : IDirectDrawSurface7;
 hRet : HRESULT;
 SurfaceDesc : TDDSurfaceDesc2;
 bltfx : TDDBLTFX;
 fcaps : TDDSCaps2;
 X,Y:Integer;
 State, LastXState:Integer;
 incparam:Integer;


procedure DoExit;
begin
 FTransImageSurface:=nil;
 FImageSurface:=nil;
 FBackgroundSurface:=nil;
 FPrimarySurface := nil;
 FDirectDraw := nil;
 Halt;
end;

function WindowProc (Hwn,msg,wpr,lpr: longint): longint; stdcall;
var
 srcrect:TRect;
begin
 result:=defwindowproc(hwn,msg,wpr,lpr);
 if msg=wm_destroy then
  DoExit;

 if msg=wm_KeyDown then
  if wpr=VK_ESCAPE then
   DoExit;

 if msg=WM_PAINT then
  begin
   ZeroMemory(@bltfx, SizeOf(bltfx));
   bltfx.dwSize := sizeof(bltfx);
   bltfx.dwFillColor := 0;
   hRet := FBackgroundSurface.Blt(nil, nil, nil, DDBLT_COLORFILL or DDBLT_WAIT, @bltfx);
   if hRet = DDERR_SURFACELOST then//   ...
    begin
     FTransImageSurface._Restore;//  
     FImageSurface._Restore;//  
     FPrimarySurface._Restore;//  
     FBackgroundSurface._Restore;//  
     FBackgroundSurface.Blt(nil, nil, nil, DDBLT_COLORFILL or DDBLT_WAIT, @bltfx); //  

     FImageSurface := DDLoadBitmap(FDirectDraw, '1.bmp', 0, 0);// 
     FTransImageSurface := DDLoadBitmap(FDirectDraw, '2.bmp', 0, 0);// 
    end;

   FBackgroundSurface.BltFast (175, 75, FImageSurface, nil, DDBLTFAST_WAIT);//   

   // 
   srcrect.Left:=0;
   srcrect.Top:=State*90;
   srcrect.Right:=180;
   srcrect.Bottom:=State*90+90;
   FBackgroundSurface.BltFast (X, Y, FTransImageSurface, @srcrect, DDBLTFAST_WAIT or DDBLTFAST_SRCCOLORKEY);

   FPrimarySurface.Flip(nil, DDFLIP_WAIT);// 
  end;
end;

begin
 FTransImageSurface:=nil;
 FImageSurface:=nil;
 FPrimarySurface:=nil;
 FBackgroundSurface:=nil;
 incparam:=1;
 x:=0;
 LastXState:=0;
 y:=random(400);

 instance :=GetModuleHandle(nil);
 with WindowClass do
  begin
   style:=CS_HRedraw or CS_VRedraw;
   Lpfnwndproc:=@windowproc;
   Hinstance:=Instance;
   HbrBackground:= color_btnface;
   LpszClassName:='DX';
   Hcursor:=LoadCursor(0,IDC_ARROW);
  end;
 RegisterClass (WindowClass);

 Handle:=CreateWindowEx (0,'DX','',WS_POPUP, 5,5, GetSystemMetrics (SM_CXSCREEN), GetSystemMetrics (SM_CYSCREEN),0,0,instance, nil);
 UpdateWindow (Handle);

 hRet := DirectDrawCreateEx (nil, FDirectDraw, IDirectDraw7, nil);
 if hRet <> DD_OK then Halt;

 FDirectDraw.SetCooperativeLevel(Handle, DDSCL_FULLSCREEN or DDSCL_EXCLUSIVE);
 FDirectDraw.SetDisplayMode (800, 600, 16, 0, 0);

 FillChar (SurfaceDesc, SizeOf(SurfaceDesc), 0);//   SurfaceDesc
 SurfaceDesc.dwSize := SizeOf(SurfaceDesc);//    ( )
 SurfaceDesc.dwFlags := DDSD_CAPS or DDSD_BACKBUFFERCOUNT;
 SurfaceDesc.dwBackBufferCount := 1;//   
 SurfaceDesc.ddsCaps.dwCaps := DDSCAPS_PRIMARYSURFACE or
        DDSCAPS_FLIP or DDSCAPS_COMPLEX;
  FDirectDraw.CreateSurface(SurfaceDesc, FPrimarySurface, nil);//  

 FillChar(fcaps, SizeOf(fcaps), 0);//  fcaps.
 fcaps.dwCaps := DDSCAPS_BACKBUFFER;//,     .
 FPrimarySurface.GetAttachedSurface(fcaps, FBackgroundSurface);// .

 FImageSurface := DDLoadBitmap(FDirectDraw, '1.bmp', 0, 0);
 FTransImageSurface := DDLoadBitmap(FDirectDraw, '2.bmp', 0, 0);
 DDSetColorKey(FTransImageSurface, RGB(255, 0, 255));

 ShowCursor(false);
 while true do
  begin
   if PeekMessage(msg,0,0,0,PM_REMOVE)=false then
    begin
     Inc(x);//   1
     if X-LastXState>10 then
      begin
       State:=State+incparam;// 
       if State=6 then
        incparam:=-1;
       if State=0 then
        incparam:=1;
       LastXState:=x;
      end;
     SendMessage(Handle,WM_PAINT,0, 0);
    end
   else
    begin
     translatemessage(msg);
     dispatchmessage (msg);
    end;
  end;
end.
